package com.tzld.longarticle.recommend.server.service.rank;


import com.tzld.longarticle.recommend.server.common.enums.RankStrategyEnum;
import com.tzld.longarticle.recommend.server.service.ServiceBeanFactory;
import com.tzld.longarticle.recommend.server.service.filter.strategy.BadStrategy;
import com.tzld.longarticle.recommend.server.service.filter.strategy.HistoryTitleForFwhColdStartStrategy;
import com.tzld.longarticle.recommend.server.service.filter.strategy.HistoryTitleStrategy;
import com.tzld.longarticle.recommend.server.service.filter.strategy.SensitiveStrategy;
import com.tzld.longarticle.recommend.server.service.rank.strategy.FwhColdStartRankStrategy;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import static com.tzld.longarticle.recommend.server.service.SceneConstants.FWH_COLD_START;

/**
 * @author dyp
 */
@Service
@Slf4j
public class RankService {

    public RankResult rank(RankParam param) {
        RankStrategy strategy = getRankStrategy(param);
        return strategy.rank(param);
    }

    private RankStrategy getRankStrategy(RankParam param) {

        switch (param.getScene()) {
            case FWH_COLD_START:
                return ServiceBeanFactory.getBean(FwhColdStartRankStrategy.class);
            default:
                RankStrategyEnum rankStrategyEnum = RankStrategyEnum.from(param.getStrategy());
                return (RankStrategy) ServiceBeanFactory.getBeanByName(rankStrategyEnum.getTaskExecutorName());
        }

    }

}
